// Learn cc.Class:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/class.html
//  - [English] http://docs.cocos2d-x.org/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/reference/attributes.html
//  - [English] http://docs.cocos2d-x.org/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - [Chinese] https://docs.cocos.com/creator/manual/zh/scripting/life-cycle-callbacks.html
//  - [English] https://www.cocos2d-x.org/docs/creator/manual/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        parentNode: {
            // ATTRIBUTES:
            default: null,               
            type: cc.Node,
        },

        testPrefab: {
            default: null,
            type: cc.Prefab,
        },

        btnLab: {
            default: null,
            type: cc.Label,
        }
    },

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},

    start () {
        this.enableUpdate = false;
        this.btnLab.string = "关闭";

        let cow = 40;
        let count = cow * cow;
        let width = cow * 10;
        let height = cow * 10;
        for (let i = 0; i<count; i++)
        {
            let node = cc.instantiate(this.testPrefab);
            this.parentNode.addChild(node);

            let x = (i % cow) * node.width;
            let y = (i / (cow * 2)) * node.height;
            node.setPosition(x - width / 2, y - height / 4);
        }
    },

    click () {
        let childs = this.parentNode.children;
        for(let i = 0, len = childs.length; i<len; i++)
        {
            let index = Math.random() * len;
            let node = childs[i];
            node.zIndex = index;
        }
    },

    open () {
        this.enableUpdate = !this.enableUpdate;
        this.btnLab.string = this.enableUpdate ? "开启" : "关闭";
    },

    update (dt) {
        if (this.enableUpdate) {
            this.click();
        }
    } 
});
